// components/cast_streaming/public/mojom/renderer_controller.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_CAST_STREAMING_PUBLIC_MOJOM_RENDERER_CONTROLLER_MOJOM_H_
#define COMPONENTS_CAST_STREAMING_PUBLIC_MOJOM_RENDERER_CONTROLLER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "components/cast_streaming/public/mojom/renderer_controller.mojom-shared.h"
#include "components/cast_streaming/public/mojom/renderer_controller.mojom-forward.h"
#include "media/mojo/mojom/renderer.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace cast_streaming {
namespace mojom {

class RendererControllerProxy;

template <typename ImplRefTraits>
class RendererControllerStub;

class RendererControllerRequestValidator;
class RendererControllerResponseValidator;


class  RendererController
    : public RendererControllerInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = RendererControllerInterfaceBase;
  using Proxy_ = RendererControllerProxy;

  template <typename ImplRefTraits>
  using Stub_ = RendererControllerStub<ImplRefTraits>;

  using RequestValidator_ = RendererControllerRequestValidator;
  using ResponseValidator_ = RendererControllerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kSetPlaybackControllerMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct SetPlaybackController_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~RendererController() = default;


  using SetPlaybackControllerCallback = base::OnceCallback<void()>;
  
  virtual void SetPlaybackController(::mojo::PendingReceiver<::media::mojom::Renderer> renderer, SetPlaybackControllerCallback callback) = 0;
};



class  RendererControllerProxy
    : public RendererController {
 public:
  using InterfaceType = RendererController;

  explicit RendererControllerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SetPlaybackController(::mojo::PendingReceiver<::media::mojom::Renderer> renderer, SetPlaybackControllerCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  RendererControllerStubDispatch {
 public:
  static bool Accept(RendererController* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      RendererController* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<RendererController>>
class RendererControllerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  RendererControllerStub() = default;
  ~RendererControllerStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RendererControllerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return RendererControllerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  RendererControllerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  RendererControllerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace cast_streaming

namespace mojo {

}  // namespace mojo

#endif  // COMPONENTS_CAST_STREAMING_PUBLIC_MOJOM_RENDERER_CONTROLLER_MOJOM_H_