// Copyright 2023 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   extensions/common/api/shared_module.idl
// by tools/json_schema_compiler.
// DO NOT EDIT.

#include "extensions/common/api/shared_module.h"

#include <memory>
#include <ostream>
#include <string>
#include <utility>
#include <vector>

#include "base/check.h"
#include "base/check_op.h"
#include "base/notreached.h"
#include "base/strings/string_number_conversions.h"
#include "base/strings/utf_string_conversions.h"
#include "base/values.h"
#include "tools/json_schema_compiler/util.h"
#include "tools/json_schema_compiler/manifest_parse_util.h"

#include "base/strings/string_piece.h"


using base::UTF8ToUTF16;

namespace extensions {
namespace api {
namespace shared_module {
//
// Types
//

Import::Import()
 {}

Import::~Import() = default;
Import::Import(Import&& rhs) = default;
Import& Import::operator=(Import&& rhs) = default;
// static
constexpr char Import::kId[];
// static
constexpr char Import::kMinimumVersion[];

// static
bool Import::Populate(
    const base::Value& value, Import* out, std::u16string* error) {
  DCHECK(error);
  if (!value.is_dict()) {
    DCHECK(error->empty());
    *error = u"expected dictionary, got " + UTF8ToUTF16(base::Value::GetTypeName(value.type()));
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* id_value = dict.Find("id");
  if (!id_value) {
    DCHECK(error->empty());
    *error = u"'id' is required";
    return false;
  }
  {
    auto* temp = (*id_value).GetIfString();
    if (!temp) {
      DCHECK(error->empty());
      *error = u"'id': expected id, got " + UTF8ToUTF16(base::Value::GetTypeName((*id_value).type()));
      return false;
    }
    out->id = *temp;
  }

  const base::Value* minimum_version_value = dict.Find("minimum_version");
  if (minimum_version_value) {
    {
      auto* temp = (*minimum_version_value).GetIfString();
      if (!temp) {
        DCHECK(error->empty());
        *error = u"'minimum_version': expected minimum_version, got " + UTF8ToUTF16(base::Value::GetTypeName((*minimum_version_value).type()));
        out->minimum_version = absl::nullopt;
        return false;
      }
      out->minimum_version = *temp;
    }
  }

  return true;
}

// static
std::unique_ptr<Import> Import::FromValue(const base::Value& value, std::u16string* error) {
  DCHECK(error);
  auto out = std::make_unique<Import>();
  bool result = Populate(value, out.get(), error);
  DCHECK_EQ(result, error->empty());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict Import::ToValue() const {
  base::Value::Dict to_value_result;

  to_value_result.Set("id", this->id);

  if (this->minimum_version) {
    to_value_result.Set("minimum_version", *this->minimum_version);

  }

  return to_value_result;
}

//static
bool Import::ParseFromDictionary(
const base::Value::Dict& root_dict, base::StringPiece key, Import* out, std::u16string* error, std::vector<base::StringPiece>* error_path_reversed) {
  DCHECK(out);
  DCHECK(error);
  DCHECK(error_path_reversed);

  const base::Value* value = ::json_schema_compiler::manifest_parse_util::FindKeyOfType(root_dict, key, base::Value::Type::DICTIONARY, error, error_path_reversed);
  if (!value)
    return false;
  const base::Value::Dict& dict = value->GetDict();
  if (!::json_schema_compiler::manifest_parse_util::ParseFromDictionary(dict, kId, &out->id, error, error_path_reversed)) {
    error_path_reversed->push_back(key);
    return false;
  }

  if (!::json_schema_compiler::manifest_parse_util::ParseFromDictionary(dict, kMinimumVersion, &out->minimum_version, error, error_path_reversed)) {
    error_path_reversed->push_back(key);
    return false;
  }

  return true;
}


Export::Export()
 {}

Export::~Export() = default;
Export::Export(Export&& rhs) = default;
Export& Export::operator=(Export&& rhs) = default;
// static
constexpr char Export::kAllowlist[];

// static
bool Export::Populate(
    const base::Value& value, Export* out, std::u16string* error) {
  DCHECK(error);
  if (!value.is_dict()) {
    DCHECK(error->empty());
    *error = u"expected dictionary, got " + UTF8ToUTF16(base::Value::GetTypeName(value.type()));
    return false;
  }
  const base::Value::Dict& dict = value.GetDict();
  const base::Value* allowlist_value = dict.Find("allowlist");
  if (allowlist_value) {
    {
      if (!(*allowlist_value).is_list()) {
        DCHECK(error->empty());
        *error = u"'allowlist': expected list, got " + UTF8ToUTF16(base::Value::GetTypeName((*allowlist_value).type()));
        return false;
      }
      else {
        std::u16string array_parse_error;
        if (!json_schema_compiler::util::PopulateOptionalArrayFromList((*allowlist_value).GetList(), &out->allowlist, &array_parse_error)) {
          array_parse_error = u"Error at key 'allowlist': " + array_parse_error;
          DCHECK(error->empty());
          *error = array_parse_error;
          return false;
        }
      }
    }
  }

  return true;
}

// static
std::unique_ptr<Export> Export::FromValue(const base::Value& value, std::u16string* error) {
  DCHECK(error);
  auto out = std::make_unique<Export>();
  bool result = Populate(value, out.get(), error);
  DCHECK_EQ(result, error->empty());
  if (!result)
    return nullptr;
  return out;
}

base::Value::Dict Export::ToValue() const {
  base::Value::Dict to_value_result;

  if (this->allowlist) {
    to_value_result.Set("allowlist", json_schema_compiler::util::CreateValueFromArray(*this->allowlist));

  }

  return to_value_result;
}

//static
bool Export::ParseFromDictionary(
const base::Value::Dict& root_dict, base::StringPiece key, Export* out, std::u16string* error, std::vector<base::StringPiece>* error_path_reversed) {
  DCHECK(out);
  DCHECK(error);
  DCHECK(error_path_reversed);

  const base::Value* value = ::json_schema_compiler::manifest_parse_util::FindKeyOfType(root_dict, key, base::Value::Type::DICTIONARY, error, error_path_reversed);
  if (!value)
    return false;
  const base::Value::Dict& dict = value->GetDict();
  if (!::json_schema_compiler::manifest_parse_util::ParseFromDictionary(dict, kAllowlist, &out->allowlist, error, error_path_reversed)) {
    error_path_reversed->push_back(key);
    return false;
  }

  return true;
}



//
// Manifest Keys
//

ManifestKeys::ManifestKeys()
 {}

ManifestKeys::~ManifestKeys() = default;
ManifestKeys::ManifestKeys(ManifestKeys&& rhs) = default;
ManifestKeys& ManifestKeys::operator=(ManifestKeys&& rhs) = default;
// static
constexpr char ManifestKeys::kImport[];
// static
constexpr char ManifestKeys::kExport[];

//static
bool ManifestKeys::ParseFromDictionary(
const base::Value::Dict& root_dict, ManifestKeys* out, std::u16string* error) {
  DCHECK(out);
  DCHECK(error);

  std::vector<base::StringPiece> error_path_reversed_vec;
  auto* error_path_reversed = &error_path_reversed_vec;
  const base::Value::Dict& dict = root_dict;
  if (!::json_schema_compiler::manifest_parse_util::ParseFromDictionary(dict, kImport, &out->import, error, error_path_reversed)) {
    ::json_schema_compiler::manifest_parse_util::PopulateFinalError(error, error_path_reversed);
    return false;
  }

  if (!::json_schema_compiler::manifest_parse_util::ParseFromDictionary(dict, kExport, &out->export_, error, error_path_reversed)) {
    ::json_schema_compiler::manifest_parse_util::PopulateFinalError(error, error_path_reversed);
    return false;
  }

  return true;
}


}  // namespace shared_module
}  // namespace api
}  // namespace extensions

