// services/device/public/mojom/input_service.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DEVICE_PUBLIC_MOJOM_INPUT_SERVICE_MOJOM_SHARED_H_
#define SERVICES_DEVICE_PUBLIC_MOJOM_INPUT_SERVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/device/public/mojom/input_service.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace device {
namespace mojom {
class InputDeviceInfoDataView;



}  // namespace mojom
}  // namespace device

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::device::mojom::InputDeviceInfoDataView> {
  using Data = ::device::mojom::internal::InputDeviceInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace device {
namespace mojom {


enum class InputDeviceSubsystem : int32_t {
  
  SUBSYSTEM_HID = 0,
  
  SUBSYSTEM_INPUT = 1,
  
  SUBSYSTEM_UNKNOWN = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, InputDeviceSubsystem value);
inline bool IsKnownEnumValue(InputDeviceSubsystem value) {
  return internal::InputDeviceSubsystem_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class InputDeviceType : int32_t {
  
  TYPE_BLUETOOTH = 0,
  
  TYPE_USB = 1,
  
  TYPE_SERIO = 2,
  
  TYPE_UNKNOWN = 3,
  kMinValue = 0,
  kMaxValue = 3,
};

 std::ostream& operator<<(std::ostream& os, InputDeviceType value);
inline bool IsKnownEnumValue(InputDeviceType value) {
  return internal::InputDeviceType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class InputDeviceManagerClientInterfaceBase {};

using InputDeviceManagerClientPtrDataView =
    mojo::InterfacePtrDataView<InputDeviceManagerClientInterfaceBase>;
using InputDeviceManagerClientRequestDataView =
    mojo::InterfaceRequestDataView<InputDeviceManagerClientInterfaceBase>;
using InputDeviceManagerClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<InputDeviceManagerClientInterfaceBase>;
using InputDeviceManagerClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<InputDeviceManagerClientInterfaceBase>;
class InputDeviceManagerInterfaceBase {};

using InputDeviceManagerPtrDataView =
    mojo::InterfacePtrDataView<InputDeviceManagerInterfaceBase>;
using InputDeviceManagerRequestDataView =
    mojo::InterfaceRequestDataView<InputDeviceManagerInterfaceBase>;
using InputDeviceManagerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<InputDeviceManagerInterfaceBase>;
using InputDeviceManagerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<InputDeviceManagerInterfaceBase>;


class InputDeviceInfoDataView {
 public:
  InputDeviceInfoDataView() = default;

  InputDeviceInfoDataView(
      internal::InputDeviceInfo_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadId(UserType* output) {
    
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadName(UserType* output) {
    
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  template <typename UserType>
  [[nodiscard]] bool ReadSubsystem(UserType* output) const {
    auto data_value = data_->subsystem;
    return mojo::internal::Deserialize<::device::mojom::InputDeviceSubsystem>(
        data_value, output);
  }
  InputDeviceSubsystem subsystem() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::device::mojom::InputDeviceSubsystem>(data_->subsystem));
  }
  template <typename UserType>
  [[nodiscard]] bool ReadType(UserType* output) const {
    auto data_value = data_->type;
    return mojo::internal::Deserialize<::device::mojom::InputDeviceType>(
        data_value, output);
  }
  InputDeviceType type() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::device::mojom::InputDeviceType>(data_->type));
  }
  bool is_accelerometer() const {
    return data_->is_accelerometer;
  }
  bool is_joystick() const {
    return data_->is_joystick;
  }
  bool is_key() const {
    return data_->is_key;
  }
  bool is_keyboard() const {
    return data_->is_keyboard;
  }
  bool is_mouse() const {
    return data_->is_mouse;
  }
  bool is_tablet() const {
    return data_->is_tablet;
  }
  bool is_touchpad() const {
    return data_->is_touchpad;
  }
  bool is_touchscreen() const {
    return data_->is_touchscreen;
  }
 private:
  internal::InputDeviceInfo_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace device

namespace std {

template <>
struct hash<::device::mojom::InputDeviceSubsystem>
    : public mojo::internal::EnumHashImpl<::device::mojom::InputDeviceSubsystem> {};

template <>
struct hash<::device::mojom::InputDeviceType>
    : public mojo::internal::EnumHashImpl<::device::mojom::InputDeviceType> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::device::mojom::InputDeviceSubsystem, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::device::mojom::InputDeviceSubsystem, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::device::mojom::InputDeviceSubsystem>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::device::mojom::InputDeviceType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::device::mojom::InputDeviceType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::device::mojom::InputDeviceType>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::device::mojom::InputDeviceInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::device::mojom::InputDeviceInfoDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::device::mojom::internal::InputDeviceInfo_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::id(input)) in_id = Traits::id(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->id)::BaseType> id_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_id, id_fragment);
    fragment->id.Set(
        id_fragment.is_null() ? nullptr : id_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null id in InputDeviceInfo struct");
    decltype(Traits::name(input)) in_name = Traits::name(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->name)::BaseType> name_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_name, name_fragment);
    fragment->name.Set(
        name_fragment.is_null() ? nullptr : name_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name in InputDeviceInfo struct");
    mojo::internal::Serialize<::device::mojom::InputDeviceSubsystem>(
        Traits::subsystem(input), &fragment->subsystem);
    mojo::internal::Serialize<::device::mojom::InputDeviceType>(
        Traits::type(input), &fragment->type);
    fragment->is_accelerometer = Traits::is_accelerometer(input);
    fragment->is_joystick = Traits::is_joystick(input);
    fragment->is_key = Traits::is_key(input);
    fragment->is_keyboard = Traits::is_keyboard(input);
    fragment->is_mouse = Traits::is_mouse(input);
    fragment->is_tablet = Traits::is_tablet(input);
    fragment->is_touchpad = Traits::is_touchpad(input);
    fragment->is_touchscreen = Traits::is_touchscreen(input);
  }

  static bool Deserialize(::device::mojom::internal::InputDeviceInfo_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::device::mojom::InputDeviceInfoDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace device {
namespace mojom {

inline void InputDeviceInfoDataView::GetIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->id.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void InputDeviceInfoDataView::GetNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->name.Get();
  *output = mojo::StringDataView(pointer, message_);
}



}  // namespace mojom
}  // namespace device

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct  TraceFormatTraits<::device::mojom::InputDeviceSubsystem> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::device::mojom::InputDeviceSubsystem value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct  TraceFormatTraits<::device::mojom::InputDeviceType> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::device::mojom::InputDeviceType value);
};

} // namespace perfetto

#endif  // SERVICES_DEVICE_PUBLIC_MOJOM_INPUT_SERVICE_MOJOM_SHARED_H_