// third_party/blink/public/mojom/choosers/file_chooser.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/choosers/file_chooser.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/choosers/file_chooser.mojom-params-data.h"
namespace blink {
namespace mojom {

static NOINLINE const char* FileChooserParams_ModeToStringHelper(FileChooserParams_Mode value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case FileChooserParams_Mode::kOpen:
      return "kOpen";
    case FileChooserParams_Mode::kOpenMultiple:
      return "kOpenMultiple";
    case FileChooserParams_Mode::kUploadFolder:
      return "kUploadFolder";
    case FileChooserParams_Mode::kSave:
      return "kSave";
    default:
      return nullptr;
  }
}

std::string FileChooserParams_ModeToString(FileChooserParams_Mode value) {
  const char *str = FileChooserParams_ModeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown FileChooserParams_Mode value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, FileChooserParams_Mode value) {
  return os << FileChooserParams_ModeToString(value);
}

namespace internal {
// static
bool FileChooserFileInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context,
    bool inlined) {
  if (!data) {
    DCHECK(!inlined);
    return true;
  }

  // If it is inlined, the alignment is already enforced by its enclosing
  // object. We don't have to validate that.
  DCHECK(!inlined || mojo::internal::IsAligned(data));

  if (!inlined &&
      !mojo::internal::ValidateNonInlinedUnionHeaderAndClaimMemory(
          data, validation_context)) {
    return false;
  }

  const FileChooserFileInfo_Data* object = static_cast<const FileChooserFileInfo_Data*>(data);

  if (inlined && object->is_null())
    return true;

  switch (object->tag) {

    case FileChooserFileInfo_Tag::kNativeFile: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_native_file, 1, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_native_file, validation_context))
        return false;
      return true;
    }
    case FileChooserFileInfo_Tag::kFileSystem: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_file_system, 2, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_file_system, validation_context))
        return false;
      return true;
    }
    default: {

      ReportValidationError(
          validation_context,
          mojo::internal::VALIDATION_ERROR_UNKNOWN_UNION_TAG,
          "unknown tag in FileChooserFileInfo");
      return false;
    }
  }
}


// static
bool FileChooserParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 56, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FileChooserParams_Data* object =
      static_cast<const FileChooserParams_Data*>(data);


  if (!::blink::mojom::internal::FileChooserParams_Mode_Data
        ::Validate(object->mode, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->title, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->title, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->default_file_name, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->default_file_name, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->selected_files, 4, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams selected_files_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->selected_files, validation_context,
                                         &selected_files_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->accept_types, 5, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams accept_types_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->accept_types, validation_context,
                                         &accept_types_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->requestor, 8, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->requestor, validation_context))
    return false;

  return true;
}

FileChooserParams_Data::FileChooserParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool NativeFileInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const NativeFileInfo_Data* object =
      static_cast<const NativeFileInfo_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->file_path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->file_path, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->display_name, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->display_name, validation_context))
    return false;

  return true;
}

NativeFileInfo_Data::NativeFileInfo_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FileSystemFileInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FileSystemFileInfo_Data* object =
      static_cast<const FileSystemFileInfo_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->url, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->modification_time, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->modification_time, validation_context))
    return false;

  return true;
}

FileSystemFileInfo_Data::FileSystemFileInfo_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FileChooserResult_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FileChooserResult_Data* object =
      static_cast<const FileChooserResult_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->files, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams files_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->files, validation_context,
                                         &files_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->base_directory, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->base_directory, validation_context))
    return false;

  return true;
}

FileChooserResult_Data::FileChooserResult_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FileChooser_OpenFileChooser_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FileChooser_OpenFileChooser_Params_Data* object =
      static_cast<const FileChooser_OpenFileChooser_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->params, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->params, validation_context))
    return false;

  return true;
}

FileChooser_OpenFileChooser_Params_Data::FileChooser_OpenFileChooser_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FileChooser_OpenFileChooser_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FileChooser_OpenFileChooser_ResponseParams_Data* object =
      static_cast<const FileChooser_OpenFileChooser_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->result, validation_context))
    return false;

  return true;
}

FileChooser_OpenFileChooser_ResponseParams_Data::FileChooser_OpenFileChooser_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FileChooser_EnumerateChosenDirectory_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FileChooser_EnumerateChosenDirectory_Params_Data* object =
      static_cast<const FileChooser_EnumerateChosenDirectory_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->directory_path, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->directory_path, validation_context))
    return false;

  return true;
}

FileChooser_EnumerateChosenDirectory_Params_Data::FileChooser_EnumerateChosenDirectory_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FileChooser_EnumerateChosenDirectory_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FileChooser_EnumerateChosenDirectory_ResponseParams_Data* object =
      static_cast<const FileChooser_EnumerateChosenDirectory_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->result, validation_context))
    return false;

  return true;
}

FileChooser_EnumerateChosenDirectory_ResponseParams_Data::FileChooser_EnumerateChosenDirectory_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::FileChooserParams_Mode>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::FileChooserParams_Mode value) {
  return std::move(context).WriteString(::blink::mojom::FileChooserParams_ModeToString(value));
}

} // namespace perfetto