// third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-params-data.h"
namespace blink {
namespace mojom {

static NOINLINE const char* DirectSocketFailureTypeToStringHelper(DirectSocketFailureType value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case DirectSocketFailureType::kPermissionsPolicy:
      return "kPermissionsPolicy";
    case DirectSocketFailureType::kTransientActivation:
      return "kTransientActivation";
    case DirectSocketFailureType::kUserDialog:
      return "kUserDialog";
    case DirectSocketFailureType::kResolvingToNonPublic:
      return "kResolvingToNonPublic";
    case DirectSocketFailureType::kRateLimiting:
      return "kRateLimiting";
    case DirectSocketFailureType::kCORS:
      return "kCORS";
    case DirectSocketFailureType::kEnterprisePolicy:
      return "kEnterprisePolicy";
    default:
      return nullptr;
  }
}

std::string DirectSocketFailureTypeToString(DirectSocketFailureType value) {
  const char *str = DirectSocketFailureTypeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown DirectSocketFailureType value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, DirectSocketFailureType value) {
  return os << DirectSocketFailureTypeToString(value);
}

static NOINLINE const char* DirectSocketProtocolTypeToStringHelper(DirectSocketProtocolType value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case DirectSocketProtocolType::kTcp:
      return "kTcp";
    case DirectSocketProtocolType::kUdp:
      return "kUdp";
    default:
      return nullptr;
  }
}

std::string DirectSocketProtocolTypeToString(DirectSocketProtocolType value) {
  const char *str = DirectSocketProtocolTypeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown DirectSocketProtocolType value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, DirectSocketProtocolType value) {
  return os << DirectSocketProtocolTypeToString(value);
}

namespace internal {


// static
bool DirectSocketOptions_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectSocketOptions_Data* object =
      static_cast<const DirectSocketOptions_Data*>(data);

  const mojo::internal::ContainerValidateParams local_hostname_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->local_hostname, validation_context,
                                         &local_hostname_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->remote_hostname, 3, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams remote_hostname_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->remote_hostname, validation_context,
                                         &remote_hostname_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateStruct(object->keep_alive_options, validation_context))
    return false;

  return true;
}

DirectSocketOptions_Data::DirectSocketOptions_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectSocketsService_OpenTcpSocket_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectSocketsService_OpenTcpSocket_Params_Data* object =
      static_cast<const DirectSocketsService_OpenTcpSocket_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->options, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->receiver, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->receiver,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterface(object->observer,
                                                 validation_context)) {
    return false;
  }

  return true;
}

DirectSocketsService_OpenTcpSocket_Params_Data::DirectSocketsService_OpenTcpSocket_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectSocketsService_OpenTcpSocket_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectSocketsService_OpenTcpSocket_ResponseParams_Data* object =
      static_cast<const DirectSocketsService_OpenTcpSocket_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->local_addr, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->peer_addr, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterface(object->receive_stream,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterface(object->send_stream,
                                                 validation_context)) {
    return false;
  }

  return true;
}

DirectSocketsService_OpenTcpSocket_ResponseParams_Data::DirectSocketsService_OpenTcpSocket_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectSocketsService_OpenUdpSocket_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectSocketsService_OpenUdpSocket_Params_Data* object =
      static_cast<const DirectSocketsService_OpenUdpSocket_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->options, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->receiver, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->receiver,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterface(object->listener,
                                                 validation_context)) {
    return false;
  }

  return true;
}

DirectSocketsService_OpenUdpSocket_Params_Data::DirectSocketsService_OpenUdpSocket_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectSocketsService_OpenUdpSocket_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectSocketsService_OpenUdpSocket_ResponseParams_Data* object =
      static_cast<const DirectSocketsService_OpenUdpSocket_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->local_addr, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->peer_addr, validation_context))
    return false;

  return true;
}

DirectSocketsService_OpenUdpSocket_ResponseParams_Data::DirectSocketsService_OpenUdpSocket_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectUDPSocket_ReceiveMore_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectUDPSocket_ReceiveMore_Params_Data* object =
      static_cast<const DirectUDPSocket_ReceiveMore_Params_Data*>(data);

  return true;
}

DirectUDPSocket_ReceiveMore_Params_Data::DirectUDPSocket_ReceiveMore_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectUDPSocket_Send_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectUDPSocket_Send_Params_Data* object =
      static_cast<const DirectUDPSocket_Send_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->data, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->data, validation_context))
    return false;

  return true;
}

DirectUDPSocket_Send_Params_Data::DirectUDPSocket_Send_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectUDPSocket_Send_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectUDPSocket_Send_ResponseParams_Data* object =
      static_cast<const DirectUDPSocket_Send_ResponseParams_Data*>(data);

  return true;
}

DirectUDPSocket_Send_ResponseParams_Data::DirectUDPSocket_Send_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool DirectUDPSocket_Close_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const DirectUDPSocket_Close_Params_Data* object =
      static_cast<const DirectUDPSocket_Close_Params_Data*>(data);

  return true;
}

DirectUDPSocket_Close_Params_Data::DirectUDPSocket_Close_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::DirectSocketFailureType>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::DirectSocketFailureType value) {
  return std::move(context).WriteString(::blink::mojom::DirectSocketFailureTypeToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::DirectSocketProtocolType>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::DirectSocketProtocolType value) {
  return std::move(context).WriteString(::blink::mojom::DirectSocketProtocolTypeToString(value));
}

} // namespace perfetto