// third_party/blink/public/mojom/fenced_frame/fenced_frame.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/fenced_frame/fenced_frame.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/fenced_frame/fenced_frame.mojom-params-data.h"
namespace blink {
namespace mojom {

static NOINLINE const char* FencedFrameModeToStringHelper(FencedFrameMode value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case FencedFrameMode::kDefault:
      return "kDefault";
    case FencedFrameMode::kOpaqueAds:
      return "kOpaqueAds";
    default:
      return nullptr;
  }
}

std::string FencedFrameModeToString(FencedFrameMode value) {
  const char *str = FencedFrameModeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown FencedFrameMode value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, FencedFrameMode value) {
  return os << FencedFrameModeToString(value);
}

static NOINLINE const char* ReportingDestinationToStringHelper(ReportingDestination value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case ReportingDestination::kBuyer:
      return "kBuyer";
    case ReportingDestination::kSeller:
      return "kSeller";
    case ReportingDestination::kComponentSeller:
      return "kComponentSeller";
    case ReportingDestination::kSharedStorageSelectUrl:
      return "kSharedStorageSelectUrl";
    default:
      return nullptr;
  }
}

std::string ReportingDestinationToString(ReportingDestination value) {
  const char *str = ReportingDestinationToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown ReportingDestination value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, ReportingDestination value) {
  return os << ReportingDestinationToString(value);
}

namespace internal {


// static
bool FencedFrameReporting_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FencedFrameReporting_Data* object =
      static_cast<const FencedFrameReporting_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->metadata, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams metadata_validate_params(
      new mojo::internal::ContainerValidateParams(0, ::blink::mojom::internal::ReportingDestination_Data::Validate), new mojo::internal::ContainerValidateParams(0, false, new mojo::internal::ContainerValidateParams(new mojo::internal::ContainerValidateParams(0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr)), new mojo::internal::ContainerValidateParams(0, false, nullptr))));
  if (!mojo::internal::ValidateContainer(object->metadata, validation_context,
                                         &metadata_validate_params)) {
    return false;
  }

  return true;
}

FencedFrameReporting_Data::FencedFrameReporting_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FencedFrameOwnerHost_Navigate_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FencedFrameOwnerHost_Navigate_Params_Data* object =
      static_cast<const FencedFrameOwnerHost_Navigate_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->url, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->url, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->navigation_start_time, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->navigation_start_time, validation_context))
    return false;

  return true;
}

FencedFrameOwnerHost_Navigate_Params_Data::FencedFrameOwnerHost_Navigate_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::FencedFrameMode>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::FencedFrameMode value) {
  return std::move(context).WriteString(::blink::mojom::FencedFrameModeToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::ReportingDestination>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::ReportingDestination value) {
  return std::move(context).WriteString(::blink::mojom::ReportingDestinationToString(value));
}

} // namespace perfetto