// third_party/blink/public/mojom/payments/payment_credential.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/payments/payment_credential.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/payments/payment_credential.mojom-params-data.h"
namespace payments {
namespace mojom {

static NOINLINE const char* PaymentCredentialStorageStatusToStringHelper(PaymentCredentialStorageStatus value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case PaymentCredentialStorageStatus::SUCCESS:
      return "SUCCESS";
    case PaymentCredentialStorageStatus::FAILED_TO_STORE_CREDENTIAL:
      return "FAILED_TO_STORE_CREDENTIAL";
    default:
      return nullptr;
  }
}

std::string PaymentCredentialStorageStatusToString(PaymentCredentialStorageStatus value) {
  const char *str = PaymentCredentialStorageStatusToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown PaymentCredentialStorageStatus value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, PaymentCredentialStorageStatus value) {
  return os << PaymentCredentialStorageStatusToString(value);
}

namespace internal {


// static
bool PaymentCredential_StorePaymentCredential_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PaymentCredential_StorePaymentCredential_Params_Data* object =
      static_cast<const PaymentCredential_StorePaymentCredential_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->credential_id, 1, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams credential_id_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->credential_id, validation_context,
                                         &credential_id_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->rp_id, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams rp_id_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->rp_id, validation_context,
                                         &rp_id_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->user_id, 3, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams user_id_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->user_id, validation_context,
                                         &user_id_validate_params)) {
    return false;
  }

  return true;
}

PaymentCredential_StorePaymentCredential_Params_Data::PaymentCredential_StorePaymentCredential_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PaymentCredential_StorePaymentCredential_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PaymentCredential_StorePaymentCredential_ResponseParams_Data* object =
      static_cast<const PaymentCredential_StorePaymentCredential_ResponseParams_Data*>(data);


  if (!::payments::mojom::internal::PaymentCredentialStorageStatus_Data
        ::Validate(object->status, validation_context))
    return false;

  return true;
}

PaymentCredential_StorePaymentCredential_ResponseParams_Data::PaymentCredential_StorePaymentCredential_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace payments

namespace perfetto {

// static
void TraceFormatTraits<::payments::mojom::PaymentCredentialStorageStatus>::WriteIntoTrace(
   perfetto::TracedValue context, ::payments::mojom::PaymentCredentialStorageStatus value) {
  return std::move(context).WriteString(::payments::mojom::PaymentCredentialStorageStatusToString(value));
}

} // namespace perfetto